function Dsp = MIMO_Test_Channel(PARAM,Dsp)
%% input isolation
s = Dsp.TxSymbol;

%% phase noise
SigmaP = sqrt(2 * pi * PARAM.LineWidth / PARAM.BaudRate);

ThetaTx = SigmaP * randn(PARAM.SymbolLength, PARAM.Nt);
ThetaTx(1,:) = 0; %initialize 1st ThetaTx. '0' mode.
% ThetaTx(1,:) = 2 * pi * rand(1,  PARAM.Nt); %initialize 1st ThetaTx. rand mode
ThetaTx = cumsum(ThetaTx, 1);
% ThetaTx(:, ceil(PARAM.Nt/2)) = 0; %ref group = 0. for test purpose.

ThetaRx = SigmaP * randn(PARAM.SymbolLength, PARAM.Nr);
ThetaRx(1,:) = 0; %initialize 1st ThetaTx. '0' mode.
% ThetaRx(1,:) = 2 * pi * rand(1,  PARAM.Nr); %initialize 1st ThetaRx. rand mode
ThetaRx = cumsum(ThetaRx, 1);

%% channel

%Rayleigh H
H = 1 / sqrt(2) * (randn(PARAM.Nr,PARAM.Nt) + 1i * randn(PARAM.Nr,PARAM.Nt));

%fixed H
% H = [-0.00915420108188762 - 0.0491333791055117i,-0.963502035920182 + 0.444067424259760i,-1.10212770621785 + 0.460774263092381i;0.493427860872792 - 0.902877033551917i,-0.314711621738879 - 0.400653292243028i,1.00064422438494 - 0.223987009830130i;-0.481401395324880 + 1.27794592267047i,0.344231867993050 + 0.556163492690392i,-0.204136207101417 + 0.534191258005896i;1.03076274979530 + 0.504380485005208i,-0.180488509840569 - 0.890993099987442i,-0.0302386886040501 - 1.11885821588438i];

%dft matrix
% H = dftmtx(PARAM.Nt);

%identity matrix
% H = eye(PARAM.Nt);
% H = sqrt(PARAM.Nt) .* H; %power normalization

%H from mat file
% H = PARAM.ChannelTsp;

%compatible H
% KdB = 5;
% Kabs = 10 ^ (KdB / 10);
% H1 = dftmtx(PARAM.Nt);
% H2 = 1 / sqrt(2) * (randn(PARAM.Nr,PARAM.Nt) + 1i * randn(PARAM.Nr,PARAM.Nt));
% H = sqrt(Kabs/(Kabs + 1)) * H1 + sqrt(1/(Kabs + 1)) * H2;



AWGN = 1 / sqrt(2) * (       randn(PARAM.Nr,PARAM.SymbolLength) ...
                      + 1i * randn(PARAM.Nr,PARAM.SymbolLength));

s = exp(1i * ThetaTx) .* s; %Add phase noise to SymbolTx
y = (H * s.' + 1/sqrt(PARAM.SnrAbs) * AWGN).';
y = exp(1i * ThetaRx) .* y; %Add phase noise to SymbolRx

%% output
Dsp.ChSymbol  = y;
Dsp.ChThetaTx = ThetaTx;
Dsp.ChThetaRx = ThetaRx;
Dsp.ChH       = H;

%% test plot
% figure;
% plot(1:size(ThetaTx,1), ThetaTx, '.-');hold on;
% 
% figure;
% plot(1:size(ThetaRx,1), ThetaRx, 'b.-');hold on;

end %function
