function Dsp = MIMO_Test_Tx(PARAM)
%% generate data
%bit data
DataTx = randi([0 1], PARAM.DataLength, PARAM.Nt);

%symbol map
SymbolTx = zeros(PARAM.DataLength / log2(PARAM.SymbolFormat), PARAM.Nt);
for i1 = 1 : PARAM.Nt
  DataTemp = DataTx(:, i1)';
  DataTemp = reshape(DataTemp, log2(PARAM.SymbolFormat), []);
  DataTemp = DataTemp';
  SymbolTx(:, i1) = bi2de(DataTemp);
end

%QAM map
SymbolTx = qammod(SymbolTx,PARAM.SymbolFormat,'gray','UnitAveragePower',true,...
                  'PlotConstellation',false);

%% add pilot
SymbolReg = zeros(PARAM.SymbolLength, PARAM.Nt);

PilotIndex = PARAM.PilotIndex;
DataIndex = (1:PARAM.SymbolLength).';
DataIndex(PilotIndex) = [];

SymbolReg(PilotIndex, :) = repmat(PARAM.PilotSeed, ...
  PARAM.SymbolLength / PARAM.CellLength / PARAM.Nt, 1);
SymbolReg(DataIndex, :) = SymbolTx;

%% output
Dsp.TxSymbol = SymbolReg;
Dsp.TxData   = DataTx;

end %function
