function PARAM = ParameterSet()

PARAM.PlotOn = 1;

PARAM.Snr_dB = 10;
PARAM.SnrAbs = 10^(PARAM.Snr_dB/10);

PARAM.Nt = 3;
PARAM.Nr = 3;

PARAM.MimoAlgorithm = 'MMSE'; % MMSE, MLD

PARAM.SymbolFormat = 4; %M-QAM:support 2-PSK, 4-QAM, 16-QAM.
PARAM.SymbolLength = 5e3 * PARAM.Nt; % should be n * Nt.
% PARAM.SymbolLength = 5e2 * PARAM.Nt; % should be n * Nt.
PARAM.CellLength   = 10; % PilotRate = 1 / CellLength
PARAM.DataLength   = PARAM.SymbolLength * log2(PARAM.SymbolFormat) ...
                   * (PARAM.CellLength - 1) / PARAM.CellLength;

PARAM.BaudRate  = 10e9;
PARAM.LineWidth = 1e-4 * PARAM.BaudRate / 2 / pi;
% PARAM.LineWidth = 2*(4/360)^2 * PARAM.BaudRate / 2 / pi;

PARAM.PilotSeed = dftmtx(PARAM.Nt);

PARAM.FormatMap = qammod((0 : PARAM.SymbolFormat-1)', PARAM.SymbolFormat, ...
                  'gray','UnitAveragePower',true,'PlotConstellation',false);

%% wiener tap
PARAM.WienerTapHalf = 50;

%% pilot index
HeadIndex  = 1;
TailIndex  = PARAM.SymbolLength;
PilotIndex = (1:PARAM.Nt)';
PilotIndex = repmat(PilotIndex, 1, TailIndex / PARAM.CellLength / PARAM.Nt);
PilotIndex = PilotIndex ...
           + (HeadIndex : PARAM.CellLength * PARAM.Nt : TailIndex) - 1;
PARAM.PilotIndex = reshape(PilotIndex, [], 1);

PARAM.PilotRefIndex = ceil(PARAM.Nt/2);
end %function
