function Dsp = Rx_Phase_Interpolation(PARAM,Dsp)
%% input isolation & coefficients
[DataLength, ~] = size(Dsp.RxThetaRxTx);

RefIndex   = PARAM.PilotRefIndex;
IndexStep  = PARAM.CellLength * PARAM.Nt;
PhaseIndex = RefIndex : IndexStep : DataLength * IndexStep;
DataIndex  = 1 : DataLength * IndexStep;

%% 1st-order interpolation
Theta = interp1(PhaseIndex, Dsp.RxThetaRxTx, DataIndex);
%   %NaN for Theta out of the range.

%% 0th-order interpolation
% Theta = interp1(PhaseIndex, Dsp.RxThetaRxTx, DataIndex, 'nearest');
  %NaN for Theta out of the range.

%% output
Dsp.RxThetaRxTx = Theta;
Dsp.RxThetaRxTxInterp = Theta;

%% test figure

% figure;
% plot(PhaseIndex, Dsp.RxThetaRxTx, 'ko' ); hold on;
% plot(DataIndex , Theta          , 'r.-'); hold on;

end%function
