function Dsp = SymbolDecision(PARAM,Dsp)

%% input isolation and coefficients
[DataLength,~] = size(Dsp.RxSymbol);

%% constellation to hard symbol
RxSymbol = qamdemod(Dsp.RxSymbol, PARAM.SymbolFormat,'gray', ...
                    'UnitAveragePower',true);

%% hard symbol to data
RxData = zeros(DataLength * log2(PARAM.SymbolFormat), PARAM.Nt);
for i1 = 1 : PARAM.Nt
  RxDataTemp = de2bi(RxSymbol(:, i1), log2(PARAM.SymbolFormat))';
  RxDataTemp = reshape(RxDataTemp, [], 1);
  RxData(:,i1) = RxDataTemp;
end

%% output
Dsp.RxData = RxData;

%% some test values
% TxSymbol = qamdemod(Dsp.TxSymbol, PARAM.SymbolFormat,'gray', ...
%                     'UnitAveragePower',true);
% TxSymbol(1:10:end, :) = [];
% %288 is the cuthead length
% TestOut = TxSymbol(280:290, :) - RxSymbol(1:11, :);
end%function
